#from vkmod import *
import time
import tkinter
import math
import glob
import os
import sys
import ctypes

#relevant functions from vkmod so I'm not sharing and ahk equivalent

def ldown():
    ctypes.windll.user32.mouse_event(2, 0, 0, 0, 0)
def lup():
    ctypes.windll.user32.mouse_event(4, 0, 0, 0, 0)
def gotorel(x,y):
    ctypes.windll.user32.mouse_event(1, x, y,0,0)
def keypress(k):
    if k=='screenshot':
        ctypes.windll.user32.keybd_event(0x5B, 0, 0, 0) #down
        
        ctypes.windll.user32.keybd_event(0x2C, 0, 0, 0) #down
        ctypes.windll.user32.keybd_event(0x2C, 0, 0x0002, 0) #up
        ctypes.windll.user32.keybd_event(0x5B, 0, 0x0002, 0) #up






def getNewDirNumber():
    global dirNumber
    global outputPath
    dirNumber=0
    while os.path.isdir(outputPath+"\\timelapse"+str(dirNumber)):
        dirNumber+=1

def recentfile():
    global screenshotsPath

    files_path = os.path.join(screenshotsPath, '*')

    files = sorted(glob.iglob(files_path), key=os.path.getctime, reverse=True) 
    return files[0]

def go():
    import time
    global outputPath
    global screenshotsPath
    fps=float(fpsEntry.get())
    duration=float(durationEntry.get())
    sep=float(sepEntry.get())
    frames=fps*duration

    currentRecent=recentfile()
    
    x,y=calculateVector(float(movementEntry.get()),float(magEntry.get()))

    totalx=0
    totaly=0
    actualx=0
    actualy=0
    changex=0
    changey=0
    global cdLabel
    timer=5
    for i in range(timer):
        cdLabel.config(text=str(timer-i))
        window.update()
        time.sleep(1)
    cdLabel.config(text="--")
    os.mkdir(outputPath)
    otime=time.time()
    ldown()
    count=0
    for i in range(round(frames)):
        while time.time()-otime < sep:
            time.sleep(0.2)
            window.update()
        otime=time.time()
        keypress("screenshot")
        time.sleep(0.2)
        rf=recentfile()
        if rf != currentRecent:
            os.replace(rf,outputPath+"\\"+"0"*(5-len(str(count)))+str(count)+".png")
            count+=1
        totalx+=x
        totaly+=y
        changex=round(totalx-actualx)
        changey=round(totaly-actualy)
        actualx+=changex
        actualy+=changey
        gotorel(changex,changey)
    lup()
    
def practice():
    fps=float(fpsEntry.get())
    duration=float(durationEntry.get())
    frames=fps*duration
    
    x,y=calculateVector(float(movementEntry.get()),float(magEntry.get()))

    print(x,y)
    x=x*frames
    y=y*frames

    repeats=max(abs(x),abs(y))/10
    x=round(x/repeats)
    y=round(y/repeats)
    global cdLabel
    timer=5
    for i in range(timer):
        cdLabel.config(text=str(timer-i))
        window.update()
        time.sleep(1)
    cdLabel.config(text="--")

                       
    
    ldown()
    for i in range(round(repeats)):
        gotorel(x,y)
        time.sleep(0.05)
        window.update()
    time.sleep(2)
    for i in range(round(repeats)):
        gotorel(-x,-y)
        time.sleep(0.05)
        window.update()

    lup()
        
    
    




def calculateVector(d,m):
    x=m*math.sin(math.radians(d))
    y=-m*math.cos(math.radians(d))
    return x,y



global screenshotsPath
global outputPath
global dirNumber
outputPath=sys.argv[0]
outputPath=outputPath.split("\\")
outputPath="\\".join(outputPath[0:len(outputPath)-1])
getNewDirNumber()
screenshotsPath=os.path.expanduser("~\Pictures\Screenshots")

outputPath=outputPath+"\\timelapse"+str(dirNumber)
print(outputPath)
#delay1=1
#delay2=4
#vkmod.ldown()
window=tkinter.Tk()
window.geometry("310x550")
window.title("TimelapseMaker")
window.iconbitmap("icon.ico")
fpsLabel=tkinter.Label(window,text="FPS:")
fpsLabel.pack()
fpsEntry=tkinter.Entry(window)
fpsEntry.pack()
durationLabel=tkinter.Label(window,text="Duration(seconds):")
durationLabel.pack()
durationEntry=tkinter.Entry(window)
durationEntry.pack()
sepLabel=tkinter.Label(window,text="Separation Between each frame(secconds):")
sepLabel.pack()
sepEntry=tkinter.Entry(window)
sepEntry.pack()
movementLabel=tkinter.Label(window,text="Movement direction(as a bearing):")
movementLabel.pack()
movementEntry=tkinter.Entry(window)
movementEntry.pack()
magLabel=tkinter.Label(window,text="Movement magnitude:")
magLabel.pack()
magEntry=tkinter.Entry(window)
magEntry.pack()
screenshotsLabel=tkinter.Label(window,text="ScreenShots Path:")
screenshotsLabel.pack()
screenshotsEntry=tkinter.Entry(window)
screenshotsEntry.insert(0,screenshotsPath)
screenshotsEntry.pack()
screenshotsLabel=tkinter.Label(window,text="Output Path:")
screenshotsLabel.pack()
screenshotsEntry=tkinter.Entry(window)
screenshotsEntry.insert(0,outputPath)
screenshotsEntry.pack()
goButton=tkinter.Button(window,text="GO",command=go)
goButton.pack()
pButton=tkinter.Button(window,text="Practice Camera Movements",command=practice)
pButton.pack()
warningLabel=tkinter.Label(window,wraplength=300,fg="red",text="Warning: \nThis program could result in unatended gameplay, it is suggested you remain at your computer while the timelapse is taking place. Each image taken will be saved to your screenshots folder inside your pictures. Make sure you are in the correct location before pressing go, as you will have a 10 seccond countdown for the timelapse to start.")
warningLabel.pack()
global cdLabel
cdLabel=tkinter.Label(window,text="--",font=(None,40))
cdLabel.pack()
window.mainloop()




